Package org.springframework.web.servlet.view.document

# Class AbstractPdfStamperView

java.lang.Object
org.springframework.context.support.ApplicationObjectSupport
org.springframework.web.context.support.WebApplicationObjectSupport
org.springframework.web.servlet.view.AbstractView
org.springframework.web.servlet.view.AbstractUrlBasedView
org.springframework.web.servlet.view.document.AbstractPdfStamperView

All Implemented Interfaces:
  `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanNameAware`, `org.springframework.beans.factory.InitializingBean`, `org.springframework.context.ApplicationContextAware`, `org.springframework.web.context.ServletContextAware`, `View`

public abstract class AbstractPdfStamperView extends AbstractUrlBasedView
Abstract superclass for PDF views that operate on an existing document with an AcroForm. Application-specific view classes will extend this class to merge the PDF form with model data.

This view implementation uses Bruno Lowagie's iText API. Known to work with the original iText 2.1.7 as well as its fork OpenPDF. We strongly recommend OpenPDF since it is actively maintained and fixes an important vulnerability for untrusted PDF content.

Thanks to Bryant Larsen for the suggestion and the original prototype!

Since:
  2.5.4
Author:
  Juergen Hoeller
See Also:
  - `AbstractPdfView`

## Field Summary

### Fields inherited from class org.springframework.web.servlet.view.AbstractView

`DEFAULT_CONTENT_TYPE`

### Fields inherited from class org.springframework.context.support.ApplicationObjectSupport

`logger`

### Fields inherited from interface org.springframework.web.servlet.View

`PATH_VARIABLES, RESPONSE_STATUS_ATTRIBUTE, SELECTED_CONTENT_TYPE`

## Constructor Summary

Constructors
Constructor
Description
`AbstractPdfStamperView()`

## Method Summary

Modifier and Type
Method
Description
`protected boolean`
`generatesDownloadContent()`
Return whether this view generates download content (typically binary content like PDF or Excel files).
`protected abstract void`
`mergePdfDocument(Map<String,Object> model, com.lowagie.text.pdf.PdfStamper stamper, HttpServletRequest request, HttpServletResponse response)`
Subclasses must implement this method to merge the PDF form with the given model data.
`protected com.lowagie.text.pdf.PdfReader`
`readPdfResource()`
Read the raw PDF resource into an iText PdfReader.
`protected final void`
`renderMergedOutputModel(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response)`
Subclasses must implement this method to actually render the view.

### Methods inherited from class org.springframework.web.servlet.view.AbstractUrlBasedView

`afterPropertiesSet, checkResource, getUrl, isUrlRequired, setUrl, toString`

### Methods inherited from class org.springframework.web.servlet.view.AbstractView

`addStaticAttribute, createMergedOutputModel, createRequestContext, createTemporaryOutputStream, exposeModelAsRequestAttributes, formatViewName, getAttributesMap, getBeanName, getContentType, getRequestContextAttribute, getRequestToExpose, getStaticAttributes, isExposePathVariables, prepareResponse, render, setAttributes, setAttributesCSV, setAttributesMap, setBeanName, setContentType, setExposeContextBeansAsAttributes, setExposedContextBeanNames, setExposePathVariables, setRequestContextAttribute, setResponseContentType, writeToResponse`

### Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport

`getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

### Methods inherited from class org.springframework.context.support.ApplicationObjectSupport

`getApplicationContext, getMessageSourceAccessor, initApplicationContext, obtainApplicationContext, requiredContextClass, setApplicationContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### AbstractPdfStamperView

public AbstractPdfStamperView()

## Method Details

### generatesDownloadContent

protected boolean generatesDownloadContent()
Description copied from class: `AbstractView`
Return whether this view generates download content (typically binary content like PDF or Excel files).

The default implementation returns `false`. Subclasses are encouraged to return `true` here if they know that they are generating download content that requires temporary caching on the client side, typically via the response OutputStream.

Overrides:
  `generatesDownloadContent` in class `AbstractView`
See Also:
  - `AbstractView.prepareResponse(jakarta.servlet.http.HttpServletRequest, jakarta.servlet.http.HttpServletResponse)`
  - `ServletResponse.getOutputStream()`

### renderMergedOutputModel

protected final void renderMergedOutputModel(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response) throws Exception
Description copied from class: `AbstractView`
Subclasses must implement this method to actually render the view.

The first step will be preparing the request: In the JSP case, this would mean setting model objects as request attributes. The second step will be the actual rendering of the view, for example including the JSP via a RequestDispatcher.

Specified by:
  `renderMergedOutputModel` in class `AbstractView`
Parameters:
  `model` - combined output Map (never `null`), with dynamic values taking precedence over static attributes
  `request` - current HTTP request
  `response` - current HTTP response
Throws:
  `Exception` - if rendering failed

### readPdfResource

protected com.lowagie.text.pdf.PdfReader readPdfResource() throws IOException
Read the raw PDF resource into an iText PdfReader.

The default implementation resolve the specified "url" property as ApplicationContext resource.

Returns:
  the PdfReader instance
Throws:
  `IOException` - if resource access failed
See Also:
  - `AbstractUrlBasedView.setUrl(java.lang.String)`

### mergePdfDocument

protected abstract void mergePdfDocument(Map<String,Object> model, com.lowagie.text.pdf.PdfStamper stamper, HttpServletRequest request, HttpServletResponse response) throws Exception
Subclasses must implement this method to merge the PDF form with the given model data.

This is where you are able to set values on the AcroForm. An example of what can be done at this level is:

     // get the form from the document
     AcroFields form = stamper.getAcroFields();

     // set some values on the form
     form.setField("field1", "value1");
     form.setField("field2", "value2");

     // set the disposition and filename
     response.setHeader("Content-disposition", "attachment; FILENAME=someName.pdf");

Note that the passed-in HTTP response is just supposed to be used for setting cookies or other HTTP headers. The built PDF document itself will automatically get written to the response after this method returns.

Parameters:
  `model` - the model Map
  `stamper` - the PdfStamper instance that will contain the AcroFields. You may also customize this PdfStamper instance according to your needs, for example, setting the "formFlattening" property.
  `request` - in case we need locale etc. Shouldn't look at attributes.
  `response` - in case we need to set cookies. Shouldn't write to it.
Throws:
  `Exception` - any exception that occurred during document building